<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDetailByPeriod ArrayType
 * @subpackage Arrays
 */
class ArrayOfDetailByPeriod extends AbstractStructArrayBase
{
    /**
     * The DetailByPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DetailByPeriod[]
     */
    public $DetailByPeriod;
    /**
     * Constructor method for ArrayOfDetailByPeriod
     * @uses ArrayOfDetailByPeriod::setDetailByPeriod()
     * @param \StructType\DetailByPeriod[] $detailByPeriod
     */
    public function __construct(array $detailByPeriod = array())
    {
        $this
            ->setDetailByPeriod($detailByPeriod);
    }
    /**
     * Get DetailByPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DetailByPeriod[]|null
     */
    public function getDetailByPeriod()
    {
        return isset($this->DetailByPeriod) ? $this->DetailByPeriod : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDetailByPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDetailByPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDetailByPeriodForArrayConstraintsFromSetDetailByPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDetailByPeriodDetailByPeriodItem) {
            // validation for constraint: itemType
            if (!$arrayOfDetailByPeriodDetailByPeriodItem instanceof \StructType\DetailByPeriod) {
                $invalidValues[] = is_object($arrayOfDetailByPeriodDetailByPeriodItem) ? get_class($arrayOfDetailByPeriodDetailByPeriodItem) : sprintf('%s(%s)', gettype($arrayOfDetailByPeriodDetailByPeriodItem), var_export($arrayOfDetailByPeriodDetailByPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DetailByPeriod property can only contain items of type \StructType\DetailByPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DetailByPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DetailByPeriod[] $detailByPeriod
     * @return \ArrayType\ArrayOfDetailByPeriod
     */
    public function setDetailByPeriod(array $detailByPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($detailByPeriodArrayErrorMessage = self::validateDetailByPeriodForArrayConstraintsFromSetDetailByPeriod($detailByPeriod))) {
            throw new \InvalidArgumentException($detailByPeriodArrayErrorMessage, __LINE__);
        }
        if (is_null($detailByPeriod) || (is_array($detailByPeriod) && empty($detailByPeriod))) {
            unset($this->DetailByPeriod);
        } else {
            $this->DetailByPeriod = $detailByPeriod;
        }
        return $this;
    }
    /**
     * Add item to DetailByPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\DetailByPeriod $item
     * @return \ArrayType\ArrayOfDetailByPeriod
     */
    public function addToDetailByPeriod(\StructType\DetailByPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DetailByPeriod) {
            throw new \InvalidArgumentException(sprintf('The DetailByPeriod property can only contain items of type \StructType\DetailByPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DetailByPeriod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DetailByPeriod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DetailByPeriod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DetailByPeriod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DetailByPeriod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DetailByPeriod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DetailByPeriod
     */
    public function getAttributeName()
    {
        return 'DetailByPeriod';
    }
}
