<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckQuoteParameters StructType
 * @subpackage Structs
 */
class CheckQuoteParameters extends AbstractStructBase
{
    /**
     * The CheckShAvailability
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CheckShAvailability;
    /**
     * The CheckPmsAvailability
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CheckPmsAvailability;
    /**
     * The LookForShAlternativeSuggestion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $LookForShAlternativeSuggestion;
    /**
     * The LookForPmsAlternativeSuggestion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $LookForPmsAlternativeSuggestion;
    /**
     * Constructor method for CheckQuoteParameters
     * @uses CheckQuoteParameters::setCheckShAvailability()
     * @uses CheckQuoteParameters::setCheckPmsAvailability()
     * @uses CheckQuoteParameters::setLookForShAlternativeSuggestion()
     * @uses CheckQuoteParameters::setLookForPmsAlternativeSuggestion()
     * @param bool $checkShAvailability
     * @param bool $checkPmsAvailability
     * @param bool $lookForShAlternativeSuggestion
     * @param bool $lookForPmsAlternativeSuggestion
     */
    public function __construct($checkShAvailability = null, $checkPmsAvailability = null, $lookForShAlternativeSuggestion = null, $lookForPmsAlternativeSuggestion = null)
    {
        $this
            ->setCheckShAvailability($checkShAvailability)
            ->setCheckPmsAvailability($checkPmsAvailability)
            ->setLookForShAlternativeSuggestion($lookForShAlternativeSuggestion)
            ->setLookForPmsAlternativeSuggestion($lookForPmsAlternativeSuggestion);
    }
    /**
     * Get CheckShAvailability value
     * @return bool
     */
    public function getCheckShAvailability()
    {
        return $this->CheckShAvailability;
    }
    /**
     * Set CheckShAvailability value
     * @param bool $checkShAvailability
     * @return \StructType\CheckQuoteParameters
     */
    public function setCheckShAvailability($checkShAvailability = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkShAvailability) && !is_bool($checkShAvailability)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($checkShAvailability, true), gettype($checkShAvailability)), __LINE__);
        }
        $this->CheckShAvailability = $checkShAvailability;
        return $this;
    }
    /**
     * Get CheckPmsAvailability value
     * @return bool
     */
    public function getCheckPmsAvailability()
    {
        return $this->CheckPmsAvailability;
    }
    /**
     * Set CheckPmsAvailability value
     * @param bool $checkPmsAvailability
     * @return \StructType\CheckQuoteParameters
     */
    public function setCheckPmsAvailability($checkPmsAvailability = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkPmsAvailability) && !is_bool($checkPmsAvailability)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($checkPmsAvailability, true), gettype($checkPmsAvailability)), __LINE__);
        }
        $this->CheckPmsAvailability = $checkPmsAvailability;
        return $this;
    }
    /**
     * Get LookForShAlternativeSuggestion value
     * @return bool
     */
    public function getLookForShAlternativeSuggestion()
    {
        return $this->LookForShAlternativeSuggestion;
    }
    /**
     * Set LookForShAlternativeSuggestion value
     * @param bool $lookForShAlternativeSuggestion
     * @return \StructType\CheckQuoteParameters
     */
    public function setLookForShAlternativeSuggestion($lookForShAlternativeSuggestion = null)
    {
        // validation for constraint: boolean
        if (!is_null($lookForShAlternativeSuggestion) && !is_bool($lookForShAlternativeSuggestion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($lookForShAlternativeSuggestion, true), gettype($lookForShAlternativeSuggestion)), __LINE__);
        }
        $this->LookForShAlternativeSuggestion = $lookForShAlternativeSuggestion;
        return $this;
    }
    /**
     * Get LookForPmsAlternativeSuggestion value
     * @return bool
     */
    public function getLookForPmsAlternativeSuggestion()
    {
        return $this->LookForPmsAlternativeSuggestion;
    }
    /**
     * Set LookForPmsAlternativeSuggestion value
     * @param bool $lookForPmsAlternativeSuggestion
     * @return \StructType\CheckQuoteParameters
     */
    public function setLookForPmsAlternativeSuggestion($lookForPmsAlternativeSuggestion = null)
    {
        // validation for constraint: boolean
        if (!is_null($lookForPmsAlternativeSuggestion) && !is_bool($lookForPmsAlternativeSuggestion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($lookForPmsAlternativeSuggestion, true), gettype($lookForPmsAlternativeSuggestion)), __LINE__);
        }
        $this->LookForPmsAlternativeSuggestion = $lookForPmsAlternativeSuggestion;
        return $this;
    }
}
